import { C as Component } from './Component-1d0e5b9b';

declare class HierarchyNavigation extends Component {
    private server;
    private getToken;
    private environmentFqdn;
    private clickedInstance;
    private isHierarchySelectionActive;
    private hierarchySelectorElem;
    private filterPathElem;
    private searchWrapperElem;
    private hierarchyListWrapperElem;
    private hierarchyListElem;
    private noResultsElem;
    private notFoundElem;
    private hierarchyElem;
    private instanceListElem;
    private instanceListWrapperElem;
    private lastInstanceContinuationToken;
    private usedInstanceSearchContinuationTokens;
    private envHierarchies;
    private envTypes;
    private selectedHierarchyName;
    private viewType;
    private viewTypesElem;
    private searchGloballyElem;
    private lookupGloballyElem;
    private instanceLookupLoadingElem;
    private mode;
    private searchString;
    private path;
    private originalPathBeforeReverseLookup;
    private contextMenu;
    private contextMenuProps;
    private timeSeriesIdForLookup;
    private lastLookedupInstance;
    constructor(renderTarget: Element);
    HierarchyNavigation(): void;
    render(environmentFqdn: string, getToken: any, hierarchyNavOptions?: any): Promise<void>;
    private setModeAndRequestParamsForSearch;
    private setModeAndRequestParamsForNavigate;
    private setModeAndRequestParamsForFilter;
    private renderHierarchySelection;
    private switchToSearchView;
    private requestPayload;
    private clearAndGetResults;
    private showNoResultsForSearch;
    private doExactSearchWithPossiblePaths;
    private prepareComponentForLookup;
    private getInstance;
    private simulateExpand;
    private prepareComponentForAfterLookup;
    private removeCurrentHitsOfLastLookup;
    private showNotFoundForReverseLookup;
    showInstance(timeSeriesID: Array<string | null>, hierarchyIds?: Array<string>): Promise<void>;
    private renderTree;
    private renderInstances;
    private pathSearchAndRenderResult;
    private pathSearch;
    private renderSearchResult;
    private fillDataRecursively;
    closeContextMenu: () => void;
    private prepareForContextMenu;
    drawContextMenu: (contextMenuItems: Array<ContextMenuItems>, contextMenuOptions: ContextMenuOptions) => void;
    private createHierarchyItemElem;
    private createInstanceElem;
    private hasHits;
    private hierarchyNodeIdentifier;
    private instanceNodeIdentifier;
    private instanceNodeStringToDisplay;
    private instanceNodeString;
    private clearAndHideFilterPath;
    private selectHierarchy;
    private resettingVariablesForEnvChange;
}
interface ContextMenuItems {
    name: string;
    kind: string;
    action: any;
}
interface ContextMenuOptions {
    isSelectionEnabled: boolean;
    isFilterEnabled: boolean;
    onClose: any;
}

export { HierarchyNavigation as H };
