import { H as HistoryPlayback, T as TsqExpression, G as GraphicInfo } from './HistoryPlayback-fe4b7977';

declare class ProcessGraphic extends HistoryPlayback {
    private graphicSrc;
    constructor(renderTarget: Element);
    render(environmentFqdn: string, getToken: () => Promise<string>, graphicSrc: string, data: Array<TsqExpression>, chartOptions: any): void;
    protected loadResources(): Promise<GraphicInfo>;
    protected draw(): void;
    private getResizedImageDimensions;
    protected getDataPoints(results: Array<IProcessGraphicLabelInfo>): void;
    protected updateDataMarkers(graphicValues: Array<IProcessGraphicLabelInfo>): void;
    protected parseTsqResponse(response: any): any;
    protected sanitizeAttribute(str: any): string;
}
interface IProcessGraphicLabelInfo {
    value: number;
    alias: string;
    x: number;
    y: number;
    color: string;
    onClick: Function;
}

export { ProcessGraphic as P };
