import { E as EllipsisMenu } from './EllipsisMenu-49a3b6f4';
import { L as LineChart } from './LineChart-cc780a60';
import { A as AvailabilityChart } from './AvailabilityChart-0732b69c';
import { P as PieChart } from './PieChart-10820015';
import { S as ScatterPlot } from './ScatterPlot-b5c5e0ca';
import { G as GroupedBarChart } from './GroupedBarChart-696899ee';
import { G as Grid } from './Grid-857dabed';
import { S as Slider } from './Slider-3cc76db0';
import { H as Hierarchy } from './Hierarchy-c13fdd8d';
import { C as ChartDataOptions } from './ChartDataOptions-a959434c';
import { H as Heatmap } from './Heatmap-7210afb6';
import { E as EventsTable } from './EventsTable-c29e1842';
import { M as ModelSearch } from './ModelSearch-4b64ecd6';
import { D as DateTimePicker } from './DateTimePicker-63a27c08';
import { T as TimezonePicker } from './TimezonePicker-94c23e00';
import { T as TsqExpression } from './HistoryPlayback-fe4b7977';
import { M as ModelAutocomplete } from './ModelAutocomplete-98c10a72';
import { H as HierarchyNavigation } from './HierarchyNavigation-8b3f6955';
import { S as SingleDateTimePicker } from './SingleDateTimePicker-b5dd81ac';
import { D as DateTimeButtonSingle } from './DateTimeButtonSingle-be6c28cb';
import { D as DateTimeButtonRange } from './DateTimeButtonRange-812e8565';
import { P as PlaybackControls } from './PlaybackControls-652da000';
import { P as ProcessGraphic } from './ProcessGraphic-2c665062';
import { C as ColorPicker } from './ColorPicker-10c60184';
import { G as GeoProcessGraphic } from './GeoProcessGraphic-463ea6d8';

declare class AggregateExpression extends ChartDataOptions {
    measureObject: any;
    splitByObject: any;
    predicate: Object;
    visibleSplitByCap: number;
    constructor(predicateObject: any, measureObject: any, measureTypes: Array<string>, searchSpan: any, splitByObject: any, colorOrOptionsObject: any, alias?: string, contextMenu?: Array<any>);
    toTsx(roundFromTo?: boolean): {};
}

declare const transformTsqResultsForVisualization: (tsqResults: Array<any>, options: any) => Array<any>;

declare class UXClient {
    UXClient(): void;
    DateTimePicker: typeof DateTimePicker;
    PieChart: typeof PieChart;
    ScatterPlot: typeof ScatterPlot;
    BarChart: typeof GroupedBarChart;
    LineChart: typeof LineChart;
    AvailabilityChart: typeof AvailabilityChart;
    Grid: typeof Grid;
    Slider: typeof Slider;
    Hierarchy: typeof Hierarchy;
    AggregateExpression: typeof AggregateExpression;
    TsqExpression: typeof TsqExpression;
    Heatmap: typeof Heatmap;
    EventsTable: typeof EventsTable;
    ModelSearch: typeof ModelSearch;
    ModelAutocomplete: typeof ModelAutocomplete;
    HierarchyNavigation: typeof HierarchyNavigation;
    TimezonePicker: typeof TimezonePicker;
    EllipsisMenu: typeof EllipsisMenu;
    SingleDateTimePicker: typeof SingleDateTimePicker;
    DateTimeButtonSingle: typeof DateTimeButtonSingle;
    DateTimeButtonRange: typeof DateTimeButtonRange;
    ProcessGraphic: typeof ProcessGraphic;
    PlaybackControls: typeof PlaybackControls;
    ColorPicker: typeof ColorPicker;
    GeoProcessGraphic: typeof GeoProcessGraphic;
    transformTsqResultsForVisualization: typeof transformTsqResultsForVisualization;
    transformTsxToEventsArray(events: any, options: any): any[];
    private toISONoMillis;
    transformAvailabilityForVisualization(availabilityTsx: any): Array<any>;
    transformAggregatesForVisualization(aggregates: Array<any>, options: any): Array<any>;
    createEntityKey(aggName: string, aggIndex?: number): string;
    transformTsqResultsToEventsArray(results: any): any[];
}

export { UXClient as U };
